VCMD0028040000000000COMPONENT          
Node "rSimResource"
{
Name "singularity_check"
Id 1
NodeClass 
{
Id 1
Feature "rGeoFeature"
{
Name "geo"

Visible 1

Uri "geo"
OnDemandLoad 0
UseBackfaces 0
MaterialInheritance "Disabled"
}
Feature "rGeoFeature"
{
Name "Transform"

Visible 1

Uri "transform"
OnDemandLoad 0
UseBackfaces 0
MaterialInheritance "Disabled"
}
Feature "rPrimitiveBoxFeature"
{
Name "Block"

Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -141 -91 0 1 
Visible 1
Length 
{
  Expression "282"
}

Width 
{
  Expression "182"
}

Height 
{
  Expression "2"
}

}
SimAttribute "rSimApplyMaterialAttribute"
{
Material  "light_aqua"
{
  Ambient
  {
    Red 0.170000001788139
    Green 0.185000002384186
    Blue 0.202500000596046
  }
  Diffuse
  {
    Red 0.680000007152557
    Green 0.740000009536743
    Blue 0.810000002384186
  }
  Specular
  {
    Color
    {
      Red 0.476000010967255
      Green 0.51800000667572
      Blue 0.567000031471252
    }
    Shininess 0.400000005960464
  }
}

}
VCID "62772997-a53d-4f1e-8c35-b14fe9be318b"
}
Functionality "rPythonScript"
{
Id 1
Name "PythonScript"
Script "from vcScript import *
\nfrom vcHelpers.Selection import *
\n
\nINTERVAL = 0.04
\nTOLERANCE = 0.1
\n
\napp = getApplication()
\nsim = app.Simulation
\ncomp = getComponent()
\nsimLimitCommand = comp.getProperty('StopSimulation') #app.findCommand(\"simLimitTest\")
\nart2_kinems = []
\n
\ndef OnRun():
\n  global INTERVAL, art2_kinems
\n  
\n  INTERVAL = comp.Interval
\n  if not comp.Active:
\n    return
\n
\n  for kinem in filterBehaviours(getAllComponentsBehaviours(),VC_ARTICULATEDKINEMATICS2):
\n    component = kinem.Parent.Component
\n    controller = component.findBehavioursByType( VC_ROBOTCONTROLLER )[0]
\n    mountplate = controller.FlangeNode
\n    axis5 = mountplate.Parent.Parent
\n    j_offset5 = kinem.JointZeroOffset5
\n    j5 = controller.Joints[4]
\n    art2_kinems.append( (component, axis5, j5, j_offset5) )
\n    
\n  while(True):
\n    delay(INTERVAL)
\n    sim.update()
\n    checkWristSingularity()
\n    checkPolarSingularity()
\n
\ndef checkWristSingularity():
\n  global art2_kinems
\n  for component, axis5, j5, j_offset5 in art2_kinems:
\n    if abs( j5.CurrentValue-j_offset5 ) < comp.WristSingularityTolerance:
\n      msg = 'Wrist singularity at robot %s (time: %f)' % (component.Name, sim.SimTime)
\n      if simLimitCommand.Value: #simLimitCommand.Checked:
\n        app.messageBox(msg,\"Wrist Singularity Error\",VC_MESSAGE_TYPE_ERROR,VC_MESSAGE_BUTTONS_OK)
\n        app.stopSimulation()
\n      else:
\n        print 'Warning: %s' % (msg)
\n    
\ndef checkPolarSingularity():
\n  global art2_kinems
\n  for component, axis5, j5, j_offset5 in art2_kinems:
\n    axis5_local_pos = component.InverseWorldPositionMatrix * axis5.WorldPositionMatrix
\n    axis5_vec = axis5_local_pos.P
\n    axis5_vec.Z = 0
\n    # print axis5_vec.length()
\n    if axis5_vec.length() < comp.PolarSingularityTolerance:
\n      msg = 'Polar singularity at robot %s (time: %f)' % (component.Name, sim.SimTime)
\n      if simLimitCommand.Value: #simLimitCommand.Checked:
\n        app.messageBox(msg,\"Polar Singularity Error\",VC_MESSAGE_TYPE_ERROR,VC_MESSAGE_BUTTONS_OK)
\n        app.stopSimulation()
\n      else:
\n        print 'Warning: %s' % (msg)"
CompatibilityMode 1
}
VCID 62772997-a53d-4f1e-8c35-b14fe9be318b
Revision 16
Location 1 0 0 0 0 1 0 0 0 0 1 0 1481.5244749 1659.18321474 -1.81898940355e-012 1 
ActiveSimulationLevel detailed
BackfaceMode on
BOM  0

BOMname  "Singularity Checker"

BOMdescription  "Checks wrist and polar singularities for robots with Articulated2 type kin\
ematics"

Category  "Misc"

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "Active"
    Value 0
    Group 131077
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
    }
  }
  Variable "rTLimitVariable<rDouble>"
  {
    Name "Interval"
    Value 0.02
    Group 131079
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
    Quantity "Time"
    Magnitude 1
    Min 0.001
    Max 0.5
  }
  Variable "rTLimitVariable<rDouble>"
  {
    Name "PolarSingularityTolerance"
    Value 10
    Group 131081
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
    Quantity "Distance" "VectorQuantity"
    {
      Groups
      {
        UnitGroup "Position"
        {
          Unit
          {
            Name "Position"
            Suffix ".Y"
            Factor 1
            Offset 0
          }
          Unit
          {
            Name "Position"
            Suffix ".X"
            Factor 1
            Offset 0
          }
          Unit
          {
            Name "Position"
            Suffix ".Angle"
            Factor 1
            Offset 0
          }
          Family "Position"
        }
        UnitGroup "new"
        {
          Unit
          {
            Name "Meter"
            Suffix "m"
            Factor 1000
            Offset 0
          }
          Family "Metric degrees"
          Family "new"
        }
        UnitGroup "test"
        {
          Unit
          {
            Name "Pieces/minutes"
            Suffix "pcs/min"
            Factor 0.016666666
            Offset 0
          }
          Unit
          {
            Name "Total"
            Suffix "pcs"
            Factor 1
            Offset 0
          }
        }
        UnitGroup "Mixed Distance"
        {
          Unit
          {
            Name "Pieces/minutes"
            Suffix "pcs/min"
            Factor 0.016666666
            Offset 0
          }
          Unit
          {
            Name "Total"
            Suffix "pcs"
            Factor 1
            Offset 0
          }
        }
        UnitGroup "Mixed distance"
        {
          Unit
          {
            Name "Pieces/minutes"
            Suffix "pcs/min"
            Factor 0.016666666
            Offset 0
          }
          Unit
          {
            Name "Total"
            Suffix "pcs"
            Factor 1
            Offset 0
          }
        }
        UnitGroup "Distance (Mixed)"
        {
          Unit
          {
            Name "Millimeters"
            Suffix "mm"
            Factor 1
            Offset 0
          }
          Unit
          {
            Name "Centimeters"
            Suffix "cm"
            Factor 10
            Offset 0
          }
          Unit
          {
            Name "Meters"
            Suffix "m"
            Factor 1000
            Offset 0
          }
          Unit
          {
            Name "Inches"
            Suffix "in"
            Factor 25.4
            Offset 0
          }
          Family "new"
        }
      }
    }
    Magnitude 1
    Min 0.001
    Max 200
  }
  Variable "rTVariable<rDouble>"
  {
    Name "WristSingularityTolerance"
    Value 10
    Group 131080
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
    Quantity "Angle" "VectorQuantity"
    {
      Groups
      {
        UnitGroup "eaf"
        {
          Unit
          {
            Name "ht"
            Suffix "rwhjrt"
            Factor 1
            Offset 0
          }
          Family "US degrees"
        }
        UnitGroup "Anzahl"
        {
          Unit
          {
            Name "Stück"
            Suffix "Stk"
            Factor 1
            Offset 0
          }
        }
      }
    }
    Magnitude 1
  }
  Variable "rTVariable<rBool>"
  {
    Name "StopSimulation"
    Value 0
    Group 131078
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      TRANSLATE_USING_GETTEXT
    }
  }
}
}
